*DECK EDIGET
      SUBROUTINE EDIGET(NGROUP,NGCOND,NREGIO,NBMIX ,NMERGE,IFFAC ,
     >                  ILUPS ,NSAVES,NSTATS,CURNAM,OLDNAM,NSPH  ,
     >                  KSPH  ,CNDOOR,MACGEO,NWGTH ,MXISO ,NBMICR,
     >                  NACTI ,IPRINT,MAXPTS,ICALL ,ISOTXS,
     >                  IGCR  ,EGCR  ,IMERGE,MATCOD,ISOCAR,IACTI ,
     >                  MIXMER)
C
C---------------------------  EDIGET  ---------------------------------
C
C  1- PROGRAMME STATISTICS:
C      NAME     : EDIGET
C      USE      : READ EDITION OPTIONS PARAMETERS
C      MODIFIED : 91-04-03 (G.M)
C      AUTHOR   : G.MARLEAU
C
C  2- ROUTINE PARAMETERS:
C      NGROUP   : NUMBER OF GROUPS                       I
C      NGCOND   : NUMBER OF GROUPS CONDENSED             I
C      NREGIO   : NUMBER OF REGIONS                      I
C      NBMIX    : MAXIMUM NUMBER OF MIXTURES             I
C      NMERGE   : NUMBER OF REGIONS MERGED               I
C      IFFAC    : FOUR FACTOR CALCULATION                I
C                 = 0 NO FOUR FACTORS (DEFAUT)
C                 = 1 FOUR FACTOR EVALUATION
C      ILUPS    : REMOVE UP-SCATTERING FROM OUTPUT       I
C      NSAVES   : HOMOGENIZED X-S COMPUTATION+SAVE       I
C                 = 0  NO COMPUTE NO SAVE
C                 = 1  COMPUTE, NO SAVE
C                 = 2  COMPUTE, SAVE XS
C                 = 3  COMPUTE, SAVE MICRO PERTURBATION
C      NSTATS   : STATISTICS LEVEL                       I
C                 = 0  NO STATS
C                 = 1  STATISTICS ON FLUXES
C                 = 2  STATISTICS ON REACTION RATES
C                 = 3  STATISTICS ON FLUXES + RR
C                 =-1  DELTA SIGMA (MERG COMP ONLY)
C      CURNAM   : NAME OF LCM DIRECTORY WHERE THE
C                 CURRENT RATES ARE TO BE STORED         C*12
C      OLDNAM   : NAME OF LCM DIRECTORY WHERE OLD
C                 RATES WERE STORED                      C*12
C      NSPH     : =0 NO CORRECTION (DEFAULT)
C                 =1 THE SPH FACTORS ARE READ FROM LCM
C                 =2 HOMOGENEOUS MACRO-CALCULATION (NON ITERATIVE
C                    PROCEDURE OR HEBERT-BENOIST SPH-5 PROCEDURE)
C                 =3 ANY TYPE OF PIJ MACRO-CALCULATION
C                 =4 ANY TYPE OF DIFFUSION MACRO-CALCULATION
C      KSPH     : =1 AVERAGE FLUX NORMALIZATION (DEFAULT)
C                 =2 SELENGUT NORMALIZATION
C                 =3 SELENGUT NORMALIZATION WITH SURFACE LEAKAGE
C      CNDOOR   : TYPE OF SPH MACRO-CALCULATION          C*12
C      MACGEO   : NAME OF THE SPH MACRO-GEOMETRY         C*12
C      NWGTH    : = 0 USE FLUX TO MERGE/CONDENSE P1 MATRICES
C                 = 1 USE CURRENT TO MERGE/CONDENSE P1 MATRICES
C                 = 2 USE BUCKLING-WEIGHTED COHERENT METHOD
C                     TO MERGE/CONDENSE P1 MATRICES
C                 = 3 USE BUCKLING-WEIGHTED COHERENT METHOD
C                     AND DIRECTIONAL DIAGONAL CORRECTION
C                     TO MERGE/CONDENSE P1 MATRICES
C      MXISO    : MAXIMUM NUMBER OF ISOTOPES AVAILABLE   I
C      NBMICR   : <-1: GENERATE FULL XS LIBRARY          I
C                      INCLUDING DEPLETION CHAIN AND
C                      INDEPENDANT FISSION SPECTRUM FOR
C                      (-NBMICR-1) SELECTED ISOTOPES
C                 =-1: GENERATE FULL XS LIBRARY
C                      INCLUDING DEPLETION CHAIN AND
C                      INDEPENDANT FISSION SPECTRUM FOR
C                      ALL ISOTOPES
C                 =0 : DO NOT GENERATE MICROSCOPIC
C                      XS LIBRARY
C                 =1:  PROCESS ALL ISOTOPE XS
C                 >1:  PROCESS (NBMICR-1)
C                      SELECTED ISOTOPES
C      NACTI    : NUMBER OF ACTIVATION EDIT              I
C      IPRINT   : PRINT INDEX                            I
C      MAXPTS   : MAXIMUM NUMBER OF MACRO-REGIONS        I
C      ICALL    : MAXIMUM DIRECTORY INDEX IN IPEDIT      I
C      ISOTXS   : ISOTXS ADDITIONAL EDIT FORMAT          I(2)
C                 ISOTXS(1) IS FOR FLIB OR MICR
C                 ISOTXS(2) IS FOR ACTI
C                 =0 NONE ;=1 FOR ISOTXS
C      IGCR     : CONDENSED GROUPS LIMITS                I(NGROUP+1)
C      EGCR     : CONDENSED ENERGY LIMITS                R(NGROUP+1)
C      IMERGE   : MERGED REGIONS POSITION                I(NREGIO)
C      MATCOD   : MIXTURE ASSOCIATED TO EACH REGION      I(NREGIO)
C      ISOCAR   : NAMES OF THE ISOTOPES TO PROCESS       I(2,MXISO)
C      IACTI    : ACTIVATION MIXTURES                    I(NBMIX)
C      MIXMER   : MERGE MIXTURE NUMBER                   I(NBMIX+1)
C
C---------------------------   EDIGET  --------------------------------
C
      IMPLICIT    NONE
      INTEGER     IOUT
      CHARACTER   NAMSBR*6
      PARAMETER  (IOUT=6,NAMSBR='EDIGET')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER     NGROUP,NGCOND,NREGIO,NBMIX,NMERGE,IFFAC,ILUPS,
     >            NSAVES,NSTATS,NSPH,KSPH,NWGTH,MXISO,NBMICR,
     >            NACTI,IPRINT,MAXPTS,ICALL
      CHARACTER   CURNAM*12,OLDNAM*12,CNDOOR*12,MACGEO*12
      INTEGER     ISOTXS(2),IGCR(NGROUP+1),IMERGE(NREGIO),
     >            MATCOD(NREGIO),ISOCAR(2,MXISO),IACTI(NBMIX),
     >            MIXMER(0:NBMIX)
      REAL        EGCR(NGROUP+1)
C----
C  INPUT PARAMETERS
C----
      INTEGER     ITYPLU,INTLIR
      CHARACTER   CARLIR*12
      REAL        REALIR
      DOUBLE PRECISION DBLLIR
C----
C  LOCAL PARAMETERS
C----
      INTEGER     IREGIO,IGROUP,JGROUP,IMATER,ITC,NMIXME,NTMICR,
     >            ISO
C----
C  INITIALIZE MIXMER
C----
      DO 90 IMATER=0,NBMIX
        MIXMER(IMATER)=IMATER
  90  CONTINUE
C----
C  READ OPTION NAME
C----
 100  CONTINUE
      CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
 101  CONTINUE
      IF(ITYPLU .EQ. 10) GO TO 250
      IF(ITYPLU .NE. 3) CALL XABORT(NAMSBR//
     >': READ ERROR - CHARACTER ABLE EXPECTED')
      IF(CARLIR .EQ. ';') THEN
        GO TO 250
      ELSE IF(CARLIR .EQ. 'EDIT') THEN
        CALL REDGET(ITYPLU,IPRINT,REALIR,CARLIR,DBLLIR)
        IF(ITYPLU .NE. 1) THEN
          IPRINT=1
          GO TO 101
        ENDIF
      ELSE IF(CARLIR .EQ. 'UPS') THEN
        ILUPS=1
      ELSE IF(CARLIR .EQ. 'P1SCAT') THEN
C----
C  FLUX WEIGHTING OF THE P1 MATRICES.
C----
        CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
        IF(ITYPLU .NE. 3) CALL XABORT(NAMSBR//
     >  ': READ ERROR - CHARACTER P1SCAT TYPE EXPECTED')
        IF(CARLIR .EQ. 'FLUX') THEN
          NWGTH=0
        ELSE IF(CARLIR .EQ. 'CURRENT') THEN
          NWGTH=1
        ELSE IF(CARLIR .EQ. 'COHERENT') THEN
          NWGTH=2
        ELSE IF(CARLIR .EQ. 'DIRECTIONAL') THEN
          NWGTH=3
        ENDIF
      ELSE IF(CARLIR(1:4) .EQ. 'MICR') THEN
        CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
        IF(ITYPLU .EQ. 3 .AND. CARLIR(1:4) .EQ. 'ISOT') THEN
          ISOTXS(1)=1
          CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
        ENDIF
        IF(ITYPLU .EQ. 3 .AND. CARLIR .EQ. 'ALL') THEN
          NBMICR=1
        ELSE IF(ITYPLU .EQ. 3 .AND. CARLIR .EQ. 'NONE') THEN
          NBMICR=0
        ELSE IF(ITYPLU .EQ. 1) THEN
          NTMICR=INTLIR
          IF(NTMICR .GT. MXISO) CALL XABORT(NAMSBR//': TOO MANY MICR')
          DO 200 ISO=1,NTMICR
            CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
            IF(ITYPLU .NE. 3) CALL XABORT(NAMSBR//
     >      ': READ ERROR - ISOTOPE ALIAS NAME EXPECTED')
            READ(CARLIR,'(2A4)') (ISOCAR(ITC,ISO),ITC=1,2)
 200      CONTINUE
          NBMICR=NTMICR+1
        ELSE
          CALL XABORT(NAMSBR//': READ ERROR - '//
     >    'KEY ISOTXS, ALL, NONE OR INTEGER EXPECTED AFTER MICR')
        ENDIF
      ELSE IF(CARLIR .EQ. 'FLIB') THEN
        CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
        IF(ITYPLU .EQ. 3 .AND. CARLIR(1:4) .EQ. 'ISOT') THEN
          ISOTXS(1)=1
          CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
        ENDIF
        IF(ITYPLU .EQ. 3 .AND. CARLIR .EQ. 'ALL') THEN
          NBMICR=-1
        ELSE IF(ITYPLU .EQ. 3 .AND. CARLIR .EQ. 'NONE') THEN
          NBMICR=0
        ELSE IF(ITYPLU .EQ. 1) THEN
          NTMICR=INTLIR
          IF(NTMICR .GT. MXISO) CALL XABORT(NAMSBR//': TOO MANY MICR')
          DO 201 ISO=1,NTMICR
            CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
            IF(ITYPLU .NE. 3) CALL XABORT(NAMSBR//
     >      ': READ ERROR - ISOTOPE ALIAS NAME EXPECTED')
            READ(CARLIR,'(2A4)') (ISOCAR(ITC,ISO),ITC=1,2)
 201      CONTINUE
          NBMICR=-NTMICR-1
        ELSE
          CALL XABORT(NAMSBR//': READ ERROR - '//
     >    'KEY ISOTXS, ALL, NONE OR INTEGER EXPECTED AFTER FLIB')
        ENDIF
      ELSE IF(CARLIR(1:4) .EQ. 'ACTI') THEN
        CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
        IF(ITYPLU .EQ. 3 .AND. CARLIR(1:4) .EQ. 'ISOT') THEN
          ISOTXS(2)=1
          CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
        ENDIF
        IF(ITYPLU .EQ. 3 .AND. CARLIR .EQ. 'NONE') THEN
          NACTI=0
        ELSE
          DO 202 IREGIO=1,NBMIX
            IF(ITYPLU .EQ. 1) THEN
              IF(INTLIR .GT. NBMIX) THEN
                WRITE(IOUT,9000) NAMSBR,INTLIR,NBMIX
              ELSE
                NACTI=NACTI+1
                IACTI(NACTI)=INTLIR
              ENDIF
            ELSE
              GO TO 101
            ENDIF
            IF(IREGIO .LT. NBMIX) THEN
              CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
            ENDIF
 202      CONTINUE
        ENDIF
      ELSE IF(CARLIR .EQ. 'SPH') THEN
C----
C  SPH DIRECTIVE ANALYSIS
C----
        MACGEO=' '
        KSPH=1
  103   CONTINUE
        CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
        IF(ITYPLU .NE. 3) CALL XABORT(NAMSBR//
     >  ': READ ERROR - SPH TYPE MISSING')
        IF(CARLIR .EQ. 'SELE') THEN
          KSPH=2
          CNDOOR=CARLIR
          GO TO 103
        ELSE IF(CARLIR .EQ. 'ALBS') THEN
          KSPH=3
          CNDOOR=CARLIR
          GO TO 103
        ELSE IF(CARLIR .EQ. 'MGEO') THEN
          CNDOOR=CARLIR
          CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
          IF(ITYPLU .NE. 3) CALL XABORT(NAMSBR//
     >    ': READ ERROR - SPH GEOMETRY MISSING')
          MACGEO=CARLIR
          GO TO 103
        ELSE IF(CARLIR .EQ. 'OFF') THEN
*          NO SPH CORRECTION PERFORMED
          NSPH=0
          KSPH=0
          CNDOOR=' '
        ELSE IF(CARLIR .EQ. 'SPRD') THEN
*          THE SPH FACTORS ARE READ FROM LCM
          NSPH=1
          CNDOOR=' '
        ELSE IF(CARLIR .EQ. 'HOMO') THEN
*          HOMOGENEOUS MACRO CALCULATION (NO ITERATIONS ARE PERFORMED)
          NSPH=2
          CNDOOR=' '
        ELSE IF(CARLIR .EQ. ':::') THEN
          CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
          IF(ITYPLU .NE. 3) CALL XABORT(NAMSBR//
     >    ': READ ERROR - TRACKING TYPE MISSING')
           IF(CARLIR.EQ.'JPMT:') THEN
*             JPM TRANSPORT-TRANSPORT EQUIVALENCE
             NSPH=3
             CNDOOR='JPM'
           ELSE IF(CARLIR.EQ.'SYBILT:') THEN
*             SYBIL TRANSPORT-TRANSPORT EQUIVALENCE
             NSPH=3
             CNDOOR='SYBIL'
           ELSE IF(CARLIR.EQ.'EXCELT:') THEN
*             EXCELL TRANSPORT-TRANSPORT EQUIVALENCE
             NSPH=3
             CNDOOR='EXCELL'
           ELSE IF(CARLIR.EQ.'BIVACT:') THEN
*             BIVAC TRANSPORT-DIFFUSION EQUIVALENCE
             NSPH=4
             CNDOOR='BIVAC'
           ELSE
             CALL XABORT(NAMSBR//': '//CARLIR//
     >       ' IS AN INVALID TRACKING MODULE')
           ENDIF
           GO TO 250
        ELSE
          CALL XABORT(NAMSBR//': INVALID TYPE OF MACRO-CALCULATION')
        ENDIF
      ELSE IF(CARLIR(1:4) .EQ. 'COND') THEN
C----
C  GROUP CONDENSATION DIRECTIVE ANALYSIS
C----
        DO 104 IGROUP=1,NGROUP+1
          CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
          IF(ITYPLU .EQ. 3) THEN
            IF(IGROUP .EQ. 1) THEN
              IF(CARLIR .EQ. 'NONE') THEN
                NGCOND=NGROUP
                DO 107 JGROUP=1,NGROUP
                  IGCR(JGROUP)=JGROUP
 107            CONTINUE
                CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
                GO TO 101
              ELSE
                NGCOND=1
                IGCR(NGCOND)=NGROUP
              ENDIF
            ENDIF
            GO TO 101
          ELSE IF(ITYPLU .EQ. 1) THEN
            IF(INTLIR .GT. NGROUP) INTLIR=NGROUP
            IF(NGCOND .GT. 0) THEN
              IF(INTLIR .GT. IGCR(NGCOND)) THEN
                NGCOND=NGCOND+1
                IGCR(NGCOND)=INTLIR
              ENDIF
            ELSE
              NGCOND=NGCOND+1
              IGCR(NGCOND)=INTLIR
            ENDIF
          ELSE
            IF(NGCOND .GT. 0) THEN
              IF(REALIR .LT. EGCR(NGCOND)) THEN
                NGCOND=NGCOND+1
                EGCR(NGCOND)=REALIR
              ENDIF
            ELSE
              NGCOND=NGCOND+1
              EGCR(NGCOND)=REALIR
            ENDIF
          ENDIF
 104    CONTINUE
      ELSE IF(CARLIR(1:4) .EQ. 'MERG') THEN
C----
C  MERGING DIRECTIVE ANALYSIS
C----
        CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
        IF(ITYPLU .NE. 3) CALL XABORT(NAMSBR//
     >    ': READ ERROR - MERGE TYPE MISSING')
        NSPH=0
        KSPH=0
        CNDOOR=' '
        IF(CARLIR(1:4) .EQ. 'COMP') THEN
C----
C  COMPLETE MERGE
C----
          DO 108 IREGIO=1,NREGIO
            IMERGE(IREGIO)=1
 108      CONTINUE
          NMERGE=1
          GO TO 100
        ELSE IF(CARLIR .EQ. 'GEO') THEN
C----
C  MERGE BY GEOMETRY
C----
          NMERGE=-1
          GO TO 100
        ELSE IF(CARLIR(1:3) .EQ. 'MIX') THEN
C----
C  MERGE BY MIXTURES
C----
          NMIXME=0
          DO 110 IREGIO=1,NREGIO
            NMIXME=MAX(NMIXME,MATCOD(IREGIO))
            IMERGE(IREGIO)=MIXMER(MATCOD(IREGIO))
 110      CONTINUE
          NMERGE=NMIXME
          CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
          IF(ITYPLU .EQ. 1) THEN
C----
C  SPECIFY MIXTURES TO BE MERGED
C----
            NMERGE=0
            DO 111 IMATER=1,NBMIX
              DO 112 IREGIO=1,NREGIO
                IF(MATCOD(IREGIO) .EQ. IMATER) THEN
                  NMERGE=MAX(NMERGE,INTLIR)
                  GO TO 113
                ENDIF
 112          CONTINUE
 113          CONTINUE
              MIXMER(IMATER)=INTLIR
              CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
              IF(ITYPLU .NE. 1) GO TO 116
 111        CONTINUE
 116        CONTINUE
            DO 117 IREGIO=1,NREGIO
              IMERGE(IREGIO)=MIXMER(MATCOD(IREGIO))
 117        CONTINUE
            GO TO 101
          ELSE IF(ITYPLU .EQ. 3) THEN
C----
C  ASSOCIATE ONE REGION BY MIXTURE
C----
            GO TO 101
          ELSE
            CALL XABORT(NAMSBR//
     >      ': READ ERROR - INVALID MERGE NUMBER')
          ENDIF
        ELSE IF(CARLIR(1:4) .EQ. 'REGI') THEN
C----
C  MERGE BY REGIONS
C----
          CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
          IF(ITYPLU .NE. 1) CALL XABORT(NAMSBR//
     >    ': READ ERROR - MISSING REGION NUMBER FOR MERGE')
          NMERGE=MAX(0,INTLIR)
          IMERGE(1)=INTLIR
          DO 105 IREGIO=2,NREGIO
            CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
            IF(ITYPLU .NE. 1) CALL XABORT(NAMSBR//
     >      ': READ ERROR - MISSING REGION NUMBER FOR MERGE')
            NMERGE=MAX(NMERGE,INTLIR)
            IMERGE(IREGIO)=INTLIR
 105      CONTINUE
        ELSE IF(CARLIR .EQ. 'NONE') THEN
C----
C  NO MERGE BY REGIONS
C----
          NMERGE=NREGIO
          DO 106 IREGIO=1,NREGIO
            IMERGE(IREGIO)=IREGIO
 106      CONTINUE
          GO TO 100
        ELSE
          CALL XABORT(NAMSBR//
     >    ': READ ERROR - INVALID MERGE TYPE '//CARLIR)
        ENDIF
      ELSE IF(CARLIR .EQ. 'TAKE') THEN
C----
C  TAKE DIRECTIVE ANALYSIS
C----
        CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
        IF(ITYPLU.NE.3) CALL XABORT(NAMSBR//
     >  ': READ ERROR - TAKE TYPE MISSING')
        IF(CARLIR(1:4) .EQ. 'MIX') THEN
C----
C  TAKE PER MIXTURE
C----
          NMIXME=0
          DO 120 IREGIO=1,NREGIO
            NMIXME=MAX(NMIXME,MATCOD(IREGIO))
 120      CONTINUE
          CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
          IF(ITYPLU .EQ. 1) THEN
            CALL XDRSET(MIXMER,NBMIX+1,0)
            NMERGE=0
            DO 122 IMATER=1,NBMIX
C----
C  SPECIFY MIXTURES TO BE SELECTED
C----
              IF(INTLIR .LE. NBMIX .AND. INTLIR .GT. 0)
     >          MIXMER(INTLIR)=IMATER
              NMERGE=NMERGE+1
              CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
              IF(ITYPLU .NE. 1) GO TO 123
 122        CONTINUE
          ENDIF
 123      CONTINUE
          DO 124 IREGIO=1,NREGIO
            IMERGE(IREGIO)=MIXMER(MATCOD(IREGIO))
 124      CONTINUE
          GO TO 101
        ELSE IF(CARLIR(1:4) .EQ. 'REGI') THEN
C----
C  TAKE PER REGIONS
C----
          CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
          IF(ITYPLU .NE. 1) CALL XABORT(NAMSBR//
     >    ': MISSING REGION NUMBER FOR TAKE')
          DO 125 IREGIO=1,NREGIO
            IMERGE(IREGIO)=0
 125      CONTINUE
          NMERGE=1
          IMERGE(INTLIR)=1
          DO 126 IREGIO=2,NREGIO
            CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
            IF(ITYPLU .NE. 1) GO TO 101
            NMERGE=NMERGE+1
            IMERGE(INTLIR)=IREGIO
 126      CONTINUE
        ELSE
          CALL XABORT(NAMSBR//
     >   ': READ ERROR - ILLEGAL TAKE TYPE '//CARLIR)
        ENDIF
      ELSE IF(CARLIR .EQ. 'SAVE') THEN
C----
C  SAVE DIRECTIVE ANALYSIS
C----
        NSAVES=2
        CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
        IF(ITYPLU .NE. 3) CALL XABORT(NAMSBR//
     >  ': READ ERROR - SAVE OPTION MISSING')
        IF(CARLIR .EQ. 'ON') THEN
          CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
          IF(ITYPLU .EQ. 2) THEN
            CALL XABORT(NAMSBR//
     >      ': READ ERROR - SAVE NAME OR NUMBER MISSING')
          ELSE IF(ITYPLU .EQ. 1) THEN
            WRITE(CURNAM,'(8HREF-CASE,I4)') INTLIR
            ICALL=MAX(ICALL,INTLIR)
          ELSE
            CURNAM=CARLIR
          ENDIF
        ELSE
          GO TO 101
        ENDIF
      ELSE IF(CARLIR(1:4) .EQ. 'PERT') THEN
C----
C  SAVE DIRECTIVE ANALYSIS
C----
        NSAVES=3
        NBMICR=-1
        CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
        IF(ITYPLU .NE. 3) CALL XABORT(NAMSBR//
     >  ': READ ERROR - PERT OPTION MISSING')
        IF(CARLIR(1:4) .EQ. 'REFE') THEN
          CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
          IF(ITYPLU.EQ.2) THEN
            CALL XABORT(NAMSBR//
     >      ': READ ERROR - PERT NAME OR NUMBER MISSING')
          ELSE IF(ITYPLU .EQ. 1) THEN
            WRITE(CURNAM,'(8HREF-CASE,I4)') INTLIR
          ELSE
            CURNAM=CARLIR
          ENDIF
        ELSE
          GO TO 101
        ENDIF
      ELSE IF(CARLIR(1:4) .EQ. 'STAT') THEN
C----
C  STAT DIRECTIVE ANALYSIS
C----
        CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
        IF(ITYPLU .NE. 3) CALL XABORT(NAMSBR//
     >  ': READ ERROR - STAT OPTION MISSING')
        IF(CARLIR .EQ. 'FLUX') THEN
          NSTATS=1
        ELSE IF(CARLIR .EQ. 'RATE') THEN
          NSTATS=2
        ELSE IF(CARLIR .EQ. 'ALL ') THEN
          NSTATS=3
        ELSE IF(CARLIR .EQ. 'DELS') THEN
          NSTATS=-1
        ELSE
          CALL XABORT(NAMSBR//
     >    ': READ ERROR - ILLEGAL STAT OPTION '//CARLIR)
        ENDIF
        CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
        IF(ITYPLU .NE. 3) CALL XABORT(NAMSBR//
     >  ': READ ERROR - REFERENCE FOR STAT MISSING')
        IF(CARLIR(1:4) .EQ. 'REFE') THEN
          CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
          IF(ITYPLU .EQ. 2) THEN
            CALL XABORT(NAMSBR//
     >      ': READ ERROR - REFE NAME OR NUMBER MISSING')
          ELSE IF(ITYPLU .EQ. 1) THEN
            WRITE(OLDNAM,'(8HREF-CASE,I4)') INTLIR
          ELSE
            OLDNAM=CARLIR
          ENDIF
        ELSE
          GO TO 101
        ENDIF
      ELSE IF(CARLIR .EQ. 'NBAL') THEN
        IFFAC=1000
        CALL REDGET(ITYPLU,IFFAC,REALIR,CARLIR,DBLLIR)
        IF(ITYPLU .NE. 1) GO TO 101
      ELSE IF(CARLIR(1:4) .EQ. 'MAXR') THEN
        CALL REDGET(ITYPLU,MAXPTS,REALIR,CARLIR,DBLLIR)
        IF(ITYPLU .NE. 1) CALL XABORT(NAMSBR//
     >  ': READ ERROR - MAXR NUMBER MISSING')
      ELSE
        CALL XABORT(NAMSBR//':ILLEGAL KEYWORD '//CARLIR)
      ENDIF
      GO TO 100
C----
C  RETURN
C----
  250 CONTINUE
      IF(IPRINT .GE. 2) NSAVES=MAX(1,NSAVES)
      IF(NSAVES .EQ. 0 .AND.
     >   (NSTATS .NE. 0) .OR. (IFFAC .NE. 0)) NSAVES=1
      IF(NSAVES .GE. 2 .AND. CURNAM .EQ. ' ') THEN
        IF(NSAVES .EQ. 2) THEN
          ICALL=ICALL+1
        ENDIF
        WRITE(CURNAM,'(8HREF-CASE,I4)') ICALL
      ENDIF
      RETURN
C----
C  WARNING FORMAT
C----
 9000 FORMAT(1X,A6,': *****  WARNING  *****'/
     >       ' REQUEST ACTIVATION FOR MATERIAL NUMBER = ',I10/
     >       ' MAXIMUM NUMBER OF MATERIAL PERMITTED   = ',I10/
     >       ' STANDARD ACTION -- DO NOT USE THIS MATERIAL'/
     >       ' *****************************')
      END
