*DECK PERSCA
      DOUBLE PRECISION FUNCTION PERSCA(IPFLUX,NAME,NGROUP,NUNKNO,NREG,
     >                                 KEYFLX,FGAMMA,VARFLU)
C
C---------------------------  PERSCA  ---------------------------------
C
C   1- PROGRAMME STATISTICS:
C       NAME     : PERSCA
C       USE      : COMPUTE SCALAR PRODUCT
C       AUTHOR   : T. COURAU (2000-08-01)
C
C   2- ROUTINE PARAMETERS:
C    INPUT
C       IPFLUX   : POINTER TO THE FLUX                I
C       NAME     : LIST OF STANDARD XS CONSIDERED     C(NNAM)*6
C       NGROUP   : NUMBER OF ENERGY GROUPS            I
C       NUNKNO   : NUMBER OF UNKNOWN FOR THE FLUX     I
C       NREG     : NUMBER OF REGIONS                  I
C       KEYFLX   : FLUX ELEMENTS IN UNKNOWN SYSTEM    I(NREG)
C       FGAMMA   : STORE THE GENERALIZED ADJOINT      R(NUNKNO,NGROUP)
C                  VECTOR
C       VARFLU   : STORE VECTOR TO BE MULTILIED       R(NREG,NGROUP)
C                  BY GENERALIZED ADJOINT FLUXES
C
C---------------------------   PERSCA  --------------------------------
C
      IMPLICIT    NONE
      INTEGER     IOUT,ILCMUP,ILCMDN
      CHARACTER   NAMSBR*6
      PARAMETER  (IOUT=6,NAMSBR='PERSCA',ILCMUP=1,ILCMDN=2)
C----
C  ROUTINE PARAMETERS
C----
      CHARACTER   NAME*12
      INTEGER     IPFLUX,NGROUP,NUNKNO,NREG ,KEYFLX(NREG)
      REAL        FGAMMA(NUNKNO,NGROUP), VARFLU(NREG,NGROUP)
C---
C LOCAL PARAMETERS
C---
      INTEGER      IGR,IREG
      DOUBLE PRECISION SCALPR
      SCALPR=0.D0
      CALL XDRSET(FGAMMA,NGROUP*NUNKNO,0.0)
      CALL LCMSIX(IPFLUX, NAME,ILCMUP)
      CALL FLUGFL(IPFLUX,NGROUP,NUNKNO,FGAMMA)
      CALL LCMSIX(IPFLUX,NAME,ILCMDN)
      DO 10 IGR=1,NGROUP
        DO 20 IREG=1,NREG
          SCALPR=SCALPR+DBLE(FGAMMA(KEYFLX(IREG),IGR)*VARFLU(IREG,IGR))
 20     CONTINUE
 10   CONTINUE
      PERSCA=SCALPR
      RETURN
      END
