*DECK SADGAS
      SUBROUTINE SADGAS(IPEDIT,IPTMP ,IPFLUX,IPLIB ,NGROUP,NBMIX ,
     >                  NREGIO,NIFISS,NEDMAC,NL    ,ITRANC,NGCOND,
     >                  NMERGE,NTENER,NNAM  ,HVECT ,IXSFL ,
     >                  MATCOD,VOLUME,KEYFLX,
     >                  IGCOND,IMERGE,FLUXES)
C
C-------------------------    SADGAS   -------------------------------
C
C  1- PROGRAMME STATISTICS:
C      NAME     : SADGAS
C      USE      : COMPUTE GENRALIZED ADJOINT SOURCES
C      AUTHOR   : T. COURAU 2000/08/01
C
C  2- ROUTINE PARAMETERS:
C    INPUT
C      IPEDIT   : POINTER TO THE GENERALIZED             I
C                 ADJOINT SOURCES & INTEGRAL PROPERTIES
C      IPTMP    : TEMPORARY POINTER TO THE GENERALIZED   I
C                 ADJOINT SOURCES
C      IPFLUX   : POINTER TO THE SOLUTION                I
C      IPLIB    : POINTER TO THE INTERNAL LIBRARY        I
C                 OR MACROLIB
C      NGROUP   : NUMBER OF GROUPS                       I
C      NBMIX    : NUMBER OF MIXTURES                     I
C      NREGIO   : NUMBER OF REGIONS                      I
C      NIFISS   : NUMBER FISSILE ISOTOPES                I
C      NEDMAC   : NUMBER OF ADITIONAL EDITION X-S        I
C      NL       : NUMBER OF LEGENDRE ORDERS              I
C      ITRANC   : TYPE OF TRANSPORT CORRECTION           I
C      NGCOND   : NUMBER OF CONDENSED GROUPS             I
C      NMERGE   : NUMBER OF REGIONS MERGED               I
C      NTENER   : ENERGY PRESENCE INDEX                  I
C      NNAM     : NUMBER OF STANDARD XS TREATED          I
C      HVECT    : EXTRA EDIT NAMES                       C(NEDMAC)*6
C      IXSFL    : FLAG FOR THE XS TO BE TREATED          I(NNAM+1)
C      MATCOD   : MIXTURE INDEX IN REGION                I(NREGIO)
C      VOLUME   : VOLUME OF REGION                       R(NREGIO)
C      KEYFLX   : AVERAGE FLUX POSITION PER REGION       I(NREGIO)
C      IGCOND   : CONDENSED GROUPS LIMITS                I(NGROUP)
C      IMERGE   : MERGED REGIONS POSITION                I(NREGIO)
C      FLUXES   : FLUXES                                 R(NREGIO,
C                                                          NGROUP)
C
C---------------------------   SADGAS  --------------------------------
C
      IMPLICIT    NONE
      INTEGER     IOUT,NSTATE,NTC,ILCMUP,ILCMDN
      CHARACTER   NAMSBR*6
      PARAMETER  (IOUT=6,NSTATE=20,NTC=3,ILCMUP=1,ILCMDN=2,
     >            NAMSBR='SADGAS')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER     IPEDIT,IPTMP,IPFLUX,IPLIB,NGROUP,NBMIX,NREGIO,
     >            NIFISS,NEDMAC,NL,ITRANC,NGCOND,NMERGE,NTENER,NNAM,
     >            IXSFL(NNAM+1),MATCOD(NREGIO),KEYFLX(NREGIO),
     >            IGCOND(NGROUP),IMERGE(NREGIO)
      REAL        VOLUME(NREGIO),FLUXES(NREGIO,NGROUP)
C----
C  MEMORY ALLOCATION PARAMETERS
C----
      INTEGER     IBASE(1)
      REAL        RBASE
      COMMON      RBASE(1)
      EQUIVALENCE(RBASE(1),IBASE(1))
      INTEGER     ITAUXT,IVOLME,ISCATD,IFLINT,IDISFC,MATMC,INAMEA,
     >            IFFUEL,IFFNFT,IFUELR,INFI,IMFI,IMFF,ISAD
C----
C  LOCAL PARAMETERS
C----
      CHARACTER   HSIGN*12,HVECT(NEDMAC)*6,NAMSAV*12
      INTEGER     ISTATE(NSTATE),KCHAR(NTC),
     >            ILCMLN,ILCMTY,NELEMT,NELEMD,NTAUXT,ITC
      REAL        EIGENK
      LOGICAL     LSCE
C----
C  FIND THE SIGNATURE OF IPLIB
C----
      CALL LCMGET(IPLIB,'SIGNATURE',KCHAR)
      WRITE(HSIGN,'(3A4)') (KCHAR(ITC),ITC=1,3)
C----
C  ALLOCATE MEMORY FOR GROUP CONDENSATION AND MERGE
C----
      NELEMT=NMERGE*NGCOND
      NELEMD=(1+NMERGE)*NGCOND
      NTAUXT=13+3*NIFISS+NL+NEDMAC+1
      CALL SETARA(RBASE,2*NELEMD*NTAUXT,ITAUXT)
      CALL SETARA(RBASE,2*NMERGE,IVOLME)
      CALL SETARA(RBASE,2*NELEMT*NGCOND*NL,ISCATD)
      CALL LCMGET(IPFLUX,'STATE-VECTOR',ISTATE)
      CALL LCMLEN(IPFLUX,'K-EFFECTIVE',ILCMLN,ILCMTY)
      IF(ILCMLN .EQ. 1) THEN
        CALL LCMGET(IPFLUX,'K-EFFECTIVE',EIGENK)
      ELSE
        EIGENK=1.0
      ENDIF
      CALL LCMSIX(IPFLUX,'FLUXDIRECT  ',ILCMUP)
C----
C  COMPUTE GENERALIZED  ADJOINT SOURCES
C----
      LSCE=.TRUE.
      NAMSAV='MACROREF    '
      CALL SETARA(RBASE,(NBMIX+1)*NGROUP*NNAM,ISAD)
      CALL SETARA(RBASE,4*NREGIO*NGROUP,IFLINT)
      CALL SETARA(RBASE,NGCOND,IDISFC)
      CALL SETARA(IBASE,NMERGE,MATMC)
      CALL SETARA(IBASE,2*NEDMAC,INAMEA)
      CALL SETARA(RBASE,NREGIO*MAX(NIFISS,1),IFFUEL)
      CALL SETARA(RBASE,NREGIO*MAX(NIFISS,1),IFFNFT)
      CALL SETARA(IBASE,NREGIO,IFUELR)
      CALL SETARA(IBASE,2*MAX(NIFISS,1),INFI)
      CALL SETARA(IBASE,NBMIX*MAX(NIFISS,1),IMFI)
      CALL SETARA(IBASE,NMERGE*MAX(NIFISS,1),IMFF)
      IF(HSIGN .EQ. 'L_LIBRARY') CALL LCMSIX(IPLIB,'MACROLIB',ILCMUP)
      CALL SADDTX(IPEDIT,IPTMP ,IPFLUX,IPLIB ,NGROUP,NGCOND,
     >            NBMIX ,NREGIO,NMERGE,NL    ,NIFISS,NEDMAC,
     >            NTAUXT,IXSFL ,LSCE  ,NAMSAV,EIGENK,NTENER,
     >            HVECT ,ITRANC, MATCOD,VOLUME,KEYFLX,IGCOND,
     >            IMERGE,FLUXES,
     >            RBASE(IVOLME),RBASE(ITAUXT),RBASE(IFLINT),
     >            RBASE(ISCATD),IBASE(INAMEA),RBASE(IFFUEL),
     >            IBASE(IFUELR),IBASE(MATMC) ,IBASE(INFI)  ,
     >            IBASE(IMFI)  ,IBASE(IMFF)  ,RBASE(IFFNFT),
     >            RBASE(ISAD)  )
      IF(HSIGN .EQ. 'L_LIBRARY')  CALL LCMSIX(IPLIB,'MACROLIB',ILCMDN)
      CALL LCMSIX(IPFLUX,'FLUXDIRECT  ',ILCMDN)
      CALL RLSARA(IBASE(IMFF))
      CALL RLSARA(IBASE(IMFI))
      CALL RLSARA(IBASE(INFI))
      CALL RLSARA(IBASE(IFUELR))
      CALL RLSARA(RBASE(IFFNFT))
      CALL RLSARA(RBASE(IFFUEL))
      CALL RLSARA(IBASE(INAMEA))
      CALL RLSARA(IBASE(MATMC))
      CALL RLSARA(RBASE(IDISFC))
      CALL RLSARA(RBASE(IFLINT))
      CALL RLSARA(RBASE(ISAD))
      CALL RLSARA(RBASE(ISCATD))
      CALL RLSARA(RBASE(IVOLME))
      CALL RLSARA(RBASE(ITAUXT))
      RETURN
      END
