*DECK SADPXS
      SUBROUTINE  SADPXS(IPEDIT,NAMSAV,NGCOND,NMERGE,NL    ,ITRANC,
     >                   NIFISS,NEDMAC,NTAUXT,NNAM  ,NAMEAD,NAME  ,
     >                   INDICE,IXSFL ,HVECT ,EIGENK,RATECM,SCATTD,
     >                   SCATC ,IJJ   ,NJJ   ,
     >                   IPOS  ,FACT)
C
C
C---------------------------  SADPXS  ---------------------------------
C
C  1- PROGRAMME STATISTICS:
C      NAME     : SADPXS
C      USE      : PRINT HOMOGENIZED / MERGED XS
C      AUTHOR   : T. COURAU 2000/08/01
C      REMARK   : THIS ROUTINE IS INSPIRED FROM EDIPXS
C
C  2- ROUTINE PARAMETERS:
C    INPUT / OUTPUT
C      IPEDIT   : POINTER TO THE GENERALIZED            I
C                 ADJOINT SOURCES & INTEGRAL PROPERTIES
C      NGCOND   : NUMBER OF GROUPS CONDENSED            I
C      NMERGE   : NUMBER OF REGIONS MERGED              I
C      NL       : NUMBER OF LEGENDRE ORDERS             I
C      ITRANC   : TYPE OF TRANSPORT CORRECTION          I
C      NIFISS   : NUMBER OF FISSILE ISOTOPES            I
C      NEDMAC   : NUMBER OF ADITIONAL EDITION X-S       I
C      NNTOTF   : FLAG FOR NFTOT                        I
C      NTAUXT   : NUMBER OF REACTION RATE EDITS         I
C      NNAM     : NUMBER OF STANDARD XS TREATED         I
C      NAMEAD   : EXTRA EDIT NAMES                      I(2,NEDMAC)
C      NAME     : LIST OF STANDARD XS CONSIDERED        C(NNAM)*6
C      INDICE   : INDEX OF THE STANDARD XS              I(NNAM)
C                        STORED IN RATECM
C      IXSFL    : FLAG FOR THE XS TO BE TREATED         I(NNAM+1)
C                1 TOTAL, 2 TRANC, 3 NUSIGF, 4 NFTOT,
C                5 CHI, 6  SCAD
C      HVECT    : EXTRA EDIT NAMES                      C(NEDMAC)*6
C      EIGENK   : EIGENVALUE FOR PROBLEM                R
C      RATECM   : AVERAGED REGION/GROUP X-S             D(0:NMERGE,
C                 = RATECM(*,1) = FLUXES                  NGCOND,NTAUXT)
C                 = RATECM(*,2) = TOTAL
C                 = RATECM(*,3) = ABS
C                 = RATECM(*,4) = FISSIONS
C                 = RATECM(*,5) = PRODUCTIONS
C                 = RATECM(*,6) = TOTAL LEAKAGES
C                 = RATECM(*,7) = TOTAL OUT OF GROUP SCATTERING
C                 = RATECM(*,8) = DIAGONAL SCATTERING X-S
C                 = RATECM(*,9) = CHI
C                 = RATECM(*,10) = WIMS TYPE TRANSPORT CORRECTION
C                 = RATECM(*,11) = X-DIRECTED LEAKAGES
C                 = RATECM(*,12) = Y-DIRECTED LEAKAGES
C                 = RATECM(*,13) = Z-DIRECTED LEAKAGES
C                 = RATECM(*,*,13+JJ) NUSIGF FOR JJ
C                 = RATECM(*,*,13+NIFISS+JJ) CHI FOR JJ
C                 = RATECM(*,*,13+2*NIFISS+JJ) NFTOT FOR JJ
C                 = RATECM(*,*,13+3*NIFISS+IL) SIGS FOR IL
C                 = RATECM(*,*,13+3*NIFISS+NL+IE) EDIT IE
C                 = RATECM(*,*,NTAUXT)= 1/V MERGE CONDENSED
C      SCATTD   : DOUBLE PRECISION SCATTERING RATES     D(NMERGE,NGCOND,
C                                                         NGCOND,NL)
C    WORK:
C      FACT     : VECTOR STORING THE GROUP XS           R(NMERGE)
C      SCATC    : COMPRESS SCATTERING                   R(NMERGE*NGCOND)
C      IJJ      : POSITION OF FIRST DIFFUSION GROUP     I(NMERGE)
C      NJJ      : NUMBER OF DIFFUSION GROUP             I(NMERGE)
C      IPOS     : POSITION OF DIFFUSION GROUP           I(NMERGE)
C
C  3- INTERNAL PARAMETERS:
C
C      IOUT    : OUTPUT UNIT = 6                    I
C      CGRPNM  : GROUP INDEX NAME FOR LCM           C*12
C
C---------------------------   SADPSA  --------------------------------
C
      IMPLICIT          NONE
      INTEGER           IOUT,ILCMUP,ILCMDN
      CHARACTER         NAMSBR,NAMSAV*12
      PARAMETER        (IOUT=6,ILCMUP=1,ILCMDN=2,NAMSBR='SADPXS')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER           IPEDIT,NGCOND,NMERGE,NL,ITRANC,NNAM,NIFISS,
     >                  NEDMAC,NTAUXT,NAMEAD(2,NEDMAC),
     >                  INDICE(NNAM),IXSFL(NNAM+1),IJJ(NMERGE),
     >                  NJJ(NMERGE),IPOS(NMERGE)
      REAL              EIGENK,SCATC(NMERGE*NGCOND),FACT(NMERGE)
      CHARACTER         HVECT(NEDMAC)*6,NAME(NNAM)*6
      DOUBLE PRECISION  RATECM(0:NMERGE,NGCOND,NTAUXT),
     >                  SCATTD(NMERGE,NGCOND,NGCOND,NL)
C----
C  LOCAL PARAMETERS
C----
      CHARACTER         CM*2,CGRPNM*12
      INTEGER           INAM,IFIS,IMRG,IGRC,ID,IL,JGRC,IPOSIT,J2,J1
      DOUBLE PRECISION  ACCUMU
C-----
C LIST OF XS TREATED
C----
      CALL LCMSIX(IPEDIT,NAMSAV,ILCMUP)
      DO 100 IGRC=1,NGCOND
       WRITE(CGRPNM,'(5HGROUP,I3,1H/,I3)') IGRC,NGCOND
       CALL LCMSIX(IPEDIT,CGRPNM,ILCMUP)
       DO 200 INAM=1,NNAM
C----
C MERGED/HOMOGENIZED XS PRINTING
C----
        ID=INDICE(INAM)
        IF(ID.GT.0 .AND. IXSFL(INAM).EQ.1) THEN
         IF (INAM.EQ.1 .OR. INAM.EQ.2 .OR. INAM .EQ. 6) THEN
C---
C TOTAL, TRANC and ABS
C--
           DO 250 IMRG=1,NMERGE
            FACT(IMRG)=REAL(RATECM(IMRG,IGRC,ID)/RATECM(IMRG,IGRC,1))
 250       CONTINUE
           CALL LCMPUT(IPEDIT,NAME(INAM),NMERGE,2,FACT)
         ELSE IF(INAM.EQ.3 .OR. INAM.EQ.4) THEN
C----
C NUSIGF AND NFTOT XS
C----
           DO 260 IMRG=1,NMERGE
            ACCUMU=0.D0
            DO 270 IFIS=1,NIFISS
             ACCUMU=ACCUMU+RATECM(IMRG,IGRC,ID+IFIS)
 270        CONTINUE
            FACT(IMRG)=REAL(ACCUMU/RATECM(IMRG,IGRC,1))
 260       CONTINUE
           CALL LCMPUT(IPEDIT,NAME(INAM),NMERGE,2,FACT)
         ELSE IF(INAM.EQ.5) THEN
C----
C FISSION SPECTRUM (USUALLY NOT PRINTED: IXSFL(5)=0)
C----
          CALL XDRSDB(NMERGE,FACT,RATECM(1,IGRC,9),1)
          CALL LCMPUT(IPEDIT,'CHI',NMERGE,2,FACT)
         ENDIF
        ENDIF
 200   CONTINUE
C----
C SCATTERING XS PRINTING
C---
       IF(IXSFL(NNAM+1).EQ.1) THEN
         IL=1
c$$$        DO 180 IL=1,NL
         WRITE (CM,'(I2)') IL-1
         IPOSIT=0
         DO 181 IMRG=1,NMERGE
            J2=IGRC
            J1=IGRC
            DO 182 JGRC=1,NGCOND
              IF(SCATTD(IMRG,IGRC,JGRC,IL) .NE. 0.0D0) THEN
                J2=MAX(J2,JGRC)
                J1=MIN(J1,JGRC)
              ENDIF
 182        CONTINUE
            NJJ(IMRG)=J2-J1+1
            IJJ(IMRG)=J2
            IPOS(IMRG)=IPOSIT+1
            DO 183 JGRC=J2,J1,-1
              IPOSIT=IPOSIT+1
              SCATC(IPOSIT)=SCATTD(IMRG,IGRC,JGRC,IL)/
     >                             RATECM(IMRG,JGRC,1)
 183        CONTINUE
 181     CONTINUE
         CALL XDRSDB(NMERGE,FACT,SCATTD(1,IGRC,IGRC,IL),1)
         CALL LCMPUT(IPEDIT,'SCAD'//CM,IPOSIT,2,SCATC)
         CALL LCMPUT(IPEDIT,'NJJD'//CM,NMERGE,1,NJJ)
         CALL LCMPUT(IPEDIT,'IJJD'//CM,NMERGE,1,IJJ)
         CALL LCMPUT(IPEDIT,'IPOD'//CM,NMERGE,1,IPOS)
c$$$ 180    CONTINUE
       ENDIF
       CALL LCMSIX(IPEDIT,CGRPNM,ILCMDN)
 100  CONTINUE
      CALL LCMPUT(IPEDIT,'K-EFFECTIVE',1,2,EIGENK)
      CALL LCMSIX(IPEDIT,NAMSAV,ILCMDN)
      RETURN
      END
