*DECK SADSCE
      SUBROUTINE SADSCE(IPMACR,IPSYS ,NGROUP,NBMIX ,NREGIO,NUNKNO,
     >                  NIFISS,MATCOD,KEYFLX,FACTNO,ITPIJ,SUNKNO,
     >                  FUNKNO,SIGF0 ,QTOTL,
     >                  XSCAT ,SIGS0 , IJJ  ,
     >                  NJJ   , IPOS)
C
C---------------------------  SADSCE  ---------------------------------
C
C   1- PROGRAMME STATISTICS:
C      NAME     : SADSCE
C      USE      : TOTAL SOURCE COMPUTATION
C      AUTHOR   : T. COURAU 2000/08/01
C
C
C   2- ROUTINE PARAMETERS:
C    INPUT
C      IPMACR  : POINTER TO THE MACROLIB                   I
C      IPSYS    : POINTER TO THE PIJ                       I
C      NGROUP  : NUMBER OF GROUPS.                         I
C      NBMIX   : NUMBER OF MIXTURES.                       I
C      NREGIO  : NUMBER OF REGIONS.                        I
C      NUNKNO  : NUMBER OF UNKNOWN IN THE SYSTEM.          I
C      NIFISS  : NUMBER OF FISSILE ISOTOPES.               I
C      MATCOD  : MATERIAL CODE IN REGIONS.                 I(NREGIO)
C      KEYFLX  : FLUX ELEMENTS IN UNKNOWN SYSTEM.          I(NREGIO)
C      FACTNO  :  = 1/EIGNEW                               D
C      FUNKNO  : UNKNOWN VECTOR SOLVED FOR.                R(NUNKNO,
C                                                           NGROUP)
C    OUTPUT
C      SUNKNO   : FISSION SOURCE VECTOR                    R(NUNKNO,
C                                                            NGROUP)
C    SCRATCH STORAGE
C      SIGF0   : FISSION CROSS SECTION                     R(NBMIX,
C                                                            NIFISS)
C      QTOTL   : FISSION CROSS SECTION                     D(NREGIO,
C                                                            NIFISS)
C      XSCAT   : COMPRESSED SCATTERING MATRIX             R(NBMIX*
C                                                           NGROUP+1)
C      SIGS0   : WITHIN-GROUP SCATTERING                  R(0:NBMIX)
C      IJJ     : LAST SCATTERING GROUP                    I(0:NBMIX)
C      NJJ     : NUMBER OF SCATTERING GROUP           I(0:NBMIX)
C                NJJ(0) = -NGROUP
C      IPOS    : POSITION SELF SCATTERING IN XSCAT    I(0:NBMIX)
C                IPOS(0)= NGROUP+1
C---------------------------   SADSCE  --------------------------------
C
      IMPLICIT    NONE
      INTEGER     IOUT,ILCMUP,ILCMDN
      CHARACTER   NAMSBR*6
      PARAMETER  (IOUT=6,ILCMUP=1,ILCMDN=2,NAMSBR='SADSCE')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER     IPMACR,IPSYS,NGROUP,NBMIX,NREGIO,
     >            NUNKNO,NIFISS,ITPIJ
      INTEGER     MATCOD(NREGIO),KEYFLX(NREGIO),
     >             IJJ(0:NBMIX),NJJ(0:NBMIX),IPOS(0:NBMIX)
      REAL        SIGF0(NBMIX,NIFISS),
     >            SUNKNO(NUNKNO,NGROUP),FUNKNO(NUNKNO,NGROUP),
     >            SIGS0(0:NBMIX),XSCAT(0:NBMIX*NGROUP)
      DOUBLE PRECISION ACCUMU,QTOTL(NREGIO,NIFISS),FACTNO
C----
C  LOCAL PARAMETERS
C----
      CHARACTER   CGRPNM*12,CNUF*12,CCHI*12,CAN*3,CNSIGW*12
      INTEGER     IGR,JGR,IREG,IFIS,IBM,IFPOS,IGSCAT
      CNSIGW='DRAGON-S0XSC'
      CAN='D 0'
      CNUF='NUSIGF      '
      CCHI='CHI         '
      CALL XDRDBL(QTOTL,NREGIO*NIFISS,0.D0)
      CALL XDRSET(SUNKNO,NUNKNO*NGROUP,0.0)
      DO 100 IGR=1,NGROUP
          WRITE(CGRPNM,'(5HGROUP,I3,1H/,I3)') IGR,NGROUP
          CALL LCMSIX(IPMACR,CGRPNM,ILCMUP)
          CALL LCMGET(IPMACR,CNUF,SIGF0)
C----
C  TOTAL FISSION SOURCE PER ISOTOPE COMPUTATION
C----
          DO 101 IREG=1,NREGIO
            IBM=MATCOD(IREG)
            IFPOS=KEYFLX(IREG)
            IF(IBM .GT. 0) THEN
              DO 102 IFIS=1,NIFISS
                QTOTL(IREG,IFIS)=QTOTL(IREG,IFIS)
     >            +FUNKNO(IFPOS,IGR)*SIGF0(IBM,IFIS)
 102          CONTINUE
            ENDIF
 101      CONTINUE
          CALL LCMSIX(IPMACR,CGRPNM,ILCMDN)
 100  CONTINUE
      DO 110 IGR=1,NGROUP
          WRITE(CGRPNM,'(5HGROUP,I3,1H/,I3)') IGR,NGROUP
          CALL LCMSIX(IPMACR,CGRPNM,ILCMUP)
          CALL LCMGET(IPMACR,CCHI,SIGF0)
C----
C  FISSION SOURCE TERM COMPUTATION
C----
          DO 111 IREG=1,NREGIO
            IBM=MATCOD(IREG)
            IFPOS=KEYFLX(IREG)
            ACCUMU=0.D0
            IF(IBM .GT. 0) THEN
              DO 112 IFIS=1,NIFISS
                ACCUMU=ACCUMU+QTOTL(IREG,IFIS)*SIGF0(IBM,IFIS)
 112          CONTINUE
            ENDIF
            SUNKNO(IFPOS,IGR)=REAL(ACCUMU*FACTNO)
 111      CONTINUE
          CALL LCMSIX(IPMACR,CGRPNM,ILCMDN)
 110  CONTINUE
C---
C ADD DIFFUSION SOURCE
C---
      DO 210 IGR=1,NGROUP
        WRITE(CGRPNM,'(5HGROUP,I3,1H/,I3)') IGR,NGROUP
        CALL LCMSIX(IPMACR,CGRPNM,ILCMUP)
        CALL LCMSIX(IPSYS,CGRPNM,ILCMUP)
        CALL LCMGET(IPSYS,CNSIGW,SIGS0(0))
        CALL LCMGET(IPMACR,'NJJ'//CAN,NJJ(1))
        CALL LCMGET(IPMACR,'IJJ'//CAN,IJJ(1))
        CALL LCMGET(IPMACR,'IPO'//CAN,IPOS(1))
        CALL LCMGET(IPMACR,'SCA'//CAN,XSCAT(1))
C----
C  ADD TO REGION SOURCE SCATTERING SOURCES FROM ALL GROUPS
C----
        DO 70 IREG=1,NREGIO
            IBM=MATCOD(IREG)
            IGSCAT=IJJ(IBM)
            IFPOS=KEYFLX(IREG)
            DO 71 JGR=1,NJJ(IBM)
              IF(IGSCAT .NE. IGR) THEN
                 SUNKNO(IFPOS,IGR)=SUNKNO(IFPOS,IGR)
     >           +XSCAT(IPOS(IBM)+JGR-1)*FUNKNO(IFPOS,IGSCAT)
              ELSE
                 SUNKNO(IFPOS,IGR)=SUNKNO(IFPOS,IGR)
     >           +SIGS0(IBM)*FUNKNO(IFPOS,IGR)
              ENDIF
              IGSCAT=IGSCAT-1
 71         CONTINUE
 70     CONTINUE
        CALL LCMSIX(IPMACR,CGRPNM,ILCMDN)
        CALL LCMSIX(IPSYS,CGRPNM,ILCMDN)
 210  CONTINUE
      RETURN
      END
