*DECK SADSCT
      SUBROUTINE SADSCT(IPMACR,NGROUP,NGCOND,NBMIX ,NREGIO,
     >                  NMERGE,NL    ,NIFISS,NTAUXT,MATCOD,
     >                  IGCOND,IMERGE,RATECM,FLXINT,SCATTD,
     >                  XSSCAT,INGSCT,IFGSCT,
     >                  IPOSCT,XSCAT ,SADXS)
C
C---------------------------  SADSCT  ---------------------------------
C
C  1- PROGRAMME STATISTICS:
C      NAME     : SADSCT
C      USE      : EVALUATE SCATTERING REACTION RATES
C      AUTHOR   : T. COURAU 2000/08/01
C      REMARK   : THIS ROUTINE IS INSPIRED FROM EDISCT
C
C  2- ROUTINE PARAMETERS:
C     INPUT
C      IPMACR   : POINTER TO THE MACROLIB            I
C      NGROUP   : NUMBER OF GROUPS                   I
C      NGCOND   : NUMBER OF GROUPS CONDENSED         I
C      NBMIX    : NUMBER OF MIXTURES                 I
C      NREGIO   : NUMBER OF REGIONS                  I
C      NMERGE   : NUMBER OF REGIONS MERGED           I
C      NL       : NUMBER OF LEGENDRE ORDERS          I
C      NIFISS   : NUMBER OF FISSILE ISOTOPES         I
C      NTAUXT   : NUMBER OF REACTION RATE EDITS      I
C      MATCOD   : MATERIAL PER REGION                I(NREGIO)
C      IGCOND   : LIMIT CONDENSED GROUPS             I(NGCOND)
C      IMERGE   : INDEX OF MERGED REGION             I(NREGIO)
C      RATECM   : AVERAGED REGION/GROUP X-S          D(0:NMERGE,
C                 = RATECM(*,*,1) = FLUXES             NGCOND,NTAUXT)
C                 = RATECM(*,*,2) = TOTAL
C                 = RATECM(*,*,3) = ABS
C                 = RATECM(*,*,4) = FISSIONS
C                 = RATECM(*,*,5) = PRODUCTIONS
C                 = RATECM(*,*,6) = TOTAL LEAKAGES
C                 = RATECM(*,*,7) = TOTAL OUT OF GROUP SCATTERING
C                 = RATECM(*,*,8) = DIAGONAL SCATTERING X-S
C                 = RATECM(*,*,9) = CHI
C                 = RATECM(*,*,10) = WIMS TYPE TRANSPORT CORRECTION
C                 = RATECM(*,*,11) = X-DIRECTED LEAKAGES
C                 = RATECM(*,*,12) = Y-DIRECTED LEAKAGES
C                 = RATECM(*,*,13) = Z-DIRECTED LEAKAGES
C                 = RATECM(*,*,13+JJ) NUSIGF FOR JJ
C                 = RATECM(*,*,13+NIFISS+JJ) CHI FOR JJ
C                 = RATECM(*,*,13+2*NIFISS+JJ) NFTOT FOR JJ
C                 = RATECM(*,*,13+3*NIFISS+IL) SIGS FOR IL
C                 = RATECM(*,*,13+3*NIFISS+NL+IE) EDIT IE
C                 = RATECM(*,*,NTAUXT)= 1/V MERGE CONDENSED
C      FLXINT   : INTEGRATED FLUX                    R(NREGIO,NGROUP,4)
C    OUTPUT
C      XSSCAT   : SCATTERING MATRIX                  R(NGROUP,NGROUP,
C                                                              NBMIX,NL)
C      SCATTD   : DOUBLE PRECISION SCATTERING RATES  D(NMERGE,
C                                                      NGCOND,NGCOND,NL)
C    WORK
C      INGSCT   : NUMBER OF SCATTERING GROUP         I(NBMIX)
C      IFGSCT   : FIRST SCATTERING GROUP             I(NBMIX)
C      IPOSCT   : SCATTERING POSITION                I(NBMIX)
C      XSCAT    : COMPRESSED SCATTERING MATRIX       R(NBMIX*NGROUP)
C
C---------------------------   SADSCT  --------------------------------
C
      IMPLICIT         NONE
      INTEGER          IOUT,ILCMUP,ILCMDN
      CHARACTER        NAMSBR*6
      PARAMETER       (IOUT=6,ILCMUP=1,ILCMDN=2,NAMSBR='SADSCT')
      INTEGER          ILCMLN,ITYLCM
      INTEGER          IPMACR,NGROUP,NGCOND,NBMIX,NREGIO,NMERGE,
     >                 NL,NIFISS,NTAUXT, MATCOD(NREGIO),IGCOND(NGCOND),
     >                 IMERGE(NREGIO),INGSCT(NBMIX),IFGSCT(NBMIX),
     >                 IPOSCT(NBMIX)
      REAL             FLXINT(NREGIO,NGROUP,4),
     >                 XSSCAT(NBMIX,NGROUP,NGROUP,NL),
     >                 XSCAT(NGROUP*NBMIX)
      REAL             SADXS(0:NBMIX,NGROUP)
      DOUBLE PRECISION SCATTD(NMERGE,NGCOND,NGCOND,NL),
     >                 RATECM(0:NMERGE,NGCOND,NTAUXT)
C----
C  LOCAL PARAMETERS
C----
      INTEGER          ILSC,IGRC,IGRFIN,IGRDEB,IGR,IL,IREGIO,MATNUM,
     >                 IMRG,NGSCAT,IGSCAT,IPOSIT,JGRC,JGRFIN,JGRDEB,
     >                 J2,J1,IPO,JGR
      CHARACTER        CGRPNM*12,CM*2
      DOUBLE PRECISION DCOR
      DOUBLE PRECISION DFACT
      ILSC=13+3*NIFISS
C----
C  SCATTERING NEUTRONS
C----
      CALL XDRSET(XSSCAT,NGROUP*NBMIX*NL*NGROUP,0.0)
      CALL XDRDBL(SCATTD,NMERGE*NGCOND*NGCOND*NL,0.0D0)
      IGRFIN=0
      DO 110 IGRC=1,NGCOND
        IGRDEB=IGRFIN+1
        IGRFIN=IGCOND(IGRC)
        DO 120 IGR=IGRDEB,IGRFIN
          WRITE(CGRPNM,'(5HGROUP,I3,1H/,I3)') IGR,NGROUP
          CALL LCMSIX(IPMACR,CGRPNM,ILCMUP)
          DO 130 IL=1,NL
            WRITE (CM,'(I2)') IL-1
            CALL LCMLEN(IPMACR,'NJJD'//CM,ILCMLN,ITYLCM)
            IF(ILCMLN .GT. 0) THEN
              CALL LCMGET(IPMACR,'NJJD'//CM,INGSCT)
              CALL LCMGET(IPMACR,'IJJD'//CM,IFGSCT)
              CALL LCMGET(IPMACR,'IPOD'//CM,IPOSCT)
              CALL LCMGET(IPMACR,'SCAD'//CM,XSCAT)
              DO 150 IREGIO=1,NREGIO
                  MATNUM=MATCOD(IREGIO)
                  IMRG=IMERGE(IREGIO)
                  IF((IMRG .GT. 0) .AND. (MATNUM .GT. 0)) THEN
                    NGSCAT=INGSCT(MATNUM)
                    IGSCAT=IFGSCT(MATNUM)
                    IPOSIT=IPOSCT(MATNUM)
                    JGRFIN=0
                    DO 151 JGRC=1,NGCOND
                      JGRDEB=JGRFIN+1
                      JGRFIN=IGCOND(JGRC)
                      J2=MIN(JGRFIN,IGSCAT)
                      J1=MAX(JGRDEB,IGSCAT-NGSCAT+1)
                      IPO=IPOSIT+IGSCAT-J2
                      DO 152 JGR=J2,J1,-1
                        XSSCAT(MATNUM,IGR,JGR,IL)=XSCAT(IPO)
                        DCOR=XSCAT(IPO)*FLXINT(IREGIO,JGR,1)
                        SCATTD(IMRG,IGRC,JGRC,IL)=DCOR
     >                      +SCATTD(IMRG,IGRC,JGRC,IL)
                        RATECM(IMRG,JGRC,ILSC+IL)=DCOR
     >                      +RATECM(IMRG,JGRC,ILSC+IL)
                        IPO=IPO+1
 152                  CONTINUE
 151                CONTINUE
                  ENDIF
 150          CONTINUE
            ENDIF
 130      CONTINUE
          CALL LCMSIX(IPMACR,CGRPNM,ILCMDN)
 120    CONTINUE
 110  CONTINUE
C----
C  Complete evaluation of absorption rates (TOTAL-SCAT)
C----
      DO 340 IGRC=1,NGCOND
        DO 341 IMRG=1,NMERGE
          DFACT=0.0D0
          DO 342 JGRC=1,NGCOND
            DFACT=DFACT+SCATTD(IMRG,JGRC,IGRC,1)
 342      CONTINUE
          RATECM(IMRG,IGRC,3)=RATECM(IMRG,IGRC,3)-DFACT
 341    CONTINUE
 340  CONTINUE
      DO 350 MATNUM=1,NBMIX
        DO 351 IGR=1,NGROUP
          DFACT=0.0D0
          DO 352 JGR=1,NGROUP
            DFACT=DFACT+XSSCAT(MATNUM,JGR,IGR,1)
 352      CONTINUE
          SADXS(MATNUM,IGR)=SADXS(MATNUM,IGR)-DFACT
 351    CONTINUE
 350  CONTINUE
      RETURN
      END
