*DECK SYBCP1
      SUBROUTINE SYBCP1 (IPTRK,ITG,IMPX,NREG,SIGT,PIJ)
*
*-----------------------------------------------------------------------
*
* CALCULATION OF THE COLLISION PROBABILITIES FOR SYBIL.
*
* GENERAL PARAMETERS:
*   IPTRK  : POINTER TO THE SYBIL TRACKING (L_TRACK SIGNATURE).
*   ITG    : TYPE OF SYBIL MODULE.
*   IMPX   : PRINT FLAG. EQUAL TO ZERO FOR NO PRINT.
*   NREG   : TOTAL NUMBER OF MERGED BLOCKS FOR WHICH SPECIFIC VALUES
*            OF THE NEUTRON FLUX AND REACTIONS RATES ARE REQUIRED.
*   SIGT   : TOTAL MACROSCOPIC CROSS SECTIONS ORDERED BY VOLUME.
*            DIMENSION SIGT(NREG)
*   PIJ    : REDUCED COLLISION PROBABILITIES MATRIX.
*            DIMENSION PIJ(NREG*NREG)
*
*---------------------------------------------- A. HEBERT 19/05/87 -----
*
      DIMENSION SIGT(*),PIJ(NREG,*),IPAR(15),IBASE(1)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
      INTEGER      IXX2I,IPIJ2I
*    
      IF(ITG.EQ.1) THEN
         PIJ(1,1)=1.0/SIGT(1)
      ELSE IF(ITG.EQ.2) THEN
         CALL LCMSIX(IPTRK,'PURE-GEOM',1)
         CALL LCMGET(IPTRK,'PARAM',IPAR)
         ITYPE=IPAR(1)
         IHEX=IPAR(2)
         IQUA2=IPAR(3)
         IF(ITYPE.GE.8) CALL LCMGET(IPTRK,'SIDE',SIDE)
         IXX2=LCMIOF(IPTRK,'XXX')
         IYY2=LCMIOF(IPTRK,'YYY')
         IZZ2=LCMIOF(IPTRK,'ZZZ')
         INCODE=LCMIOF(IPTRK,'NCODE')
         IZCODE=LCMIOF(IPTRK,'ZCODE')
         CALL LCMSIX(IPTRK,' ',2)
*
         CALL SETARA (BASE,4*NREG,IX)
         IF(ITYPE.EQ.2) THEN
            CALL SETARA (BASE,NREG+1,ITMP1)
            CALL SETARA (IBASE,NREG+1,ITMP2)
            CALL SETARA (IBASE,NREG+1,ITMP3)
            CALL SYBALP (NREG,NREG,BASE(IXX2),SIGT,PIJ,
     1      BASE(IZCODE),BASE(IZCODE+1),BASE(IX),
     2      BASE(ITMP1),IBASE(ITMP2),IBASE(ITMP3))
C----
C  SYMMETRIZE
C----
            CALL SETARA (BASE,NREG*NREG,IPIJ2I)
            CALL SETARA (BASE,NREG+1,IXX2I)
            CALL SETARA (BASE,NREG,ISIG2I)
            BASE(IXX2I)=0.0
            DO 100 IR=1,NREG   
              BASE(IXX2I+IR)=BASE(IXX2+NREG)-BASE(IXX2+NREG-IR)
              BASE(ISIG2I+IR-1)=SIGT(NREG+1-IR)
 100        CONTINUE
            CALL SYBALP (NREG,NREG,BASE(IXX2I),BASE(ISIG2I),
     1      BASE(IPIJ2I),BASE(IZCODE+1),BASE(IZCODE),BASE(IX),
     2      BASE(ITMP1),IBASE(ITMP2),IBASE(ITMP3))
            KR=IPIJ2I+NREG*NREG-1
            DO 110 IR=1,NREG
              DO 111 JR=1,NREG
                PIJ(JR,IR)=(PIJ(JR,IR)+BASE(KR))/2
                KR=KR-1
 111          CONTINUE 
 110        CONTINUE
            CALL RLSARA (BASE(ISIG2I))
            CALL RLSARA (BASE(IXX2I))
            CALL RLSARA (BASE(IPIJ2I))
            CALL RLSARA(IBASE(ITMP3))
            CALL RLSARA(IBASE(ITMP2))
            CALL RLSARA(BASE(ITMP1))
         ELSE IF(ITYPE.EQ.3) THEN
            CALL SYBALC (NREG,NREG,BASE(IXX2),SIGT,PIJ,IQUA2,
     1      BASE(IZCODE+1),BASE(IX))
         ELSE IF(ITYPE.EQ.4) THEN
            CALL SYBALS (NREG,NREG,BASE(IXX2),SIGT,PIJ,IQUA2,
     1      BASE(IZCODE+1),BASE(IX))
         ENDIF
         CALL RLSARA (BASE(IX))
      ELSE IF(ITG.EQ.3) THEN
         CALL LCMSIX(IPTRK,'DOITYOURSELF',1)
         CALL LCMGET(IPTRK,'PARAM',IPAR)
         NSUPCE=IPAR(1)
         IQUA3=IPAR(2)
         ISTAT=IPAR(3)
         INMC3=LCMIOF(IPTRK,'NMC')
         IRAYR3=LCMIOF(IPTRK,'RAYRE')
         IPROCE=LCMIOF(IPTRK,'PROCEL')
         IPOURC=LCMIOF(IPTRK,'POURCE')
         ISURFA=LCMIOF(IPTRK,'SURFA')
         CALL LCMSIX(IPTRK,' ',2)
*
         CALL SETARA(BASE,NREG,IIAP)
         CALL SETARA(BASE,NREG,IPIB)
         CALL SETARA(BASE,NREG,IPBI)
         CALL SETARA(BASE,2*NSUPCE**2,IPSS)
         CALL SETARA(BASE,NSUPCE,IPBB)
         CALL SYBRXE(NREG,NSUPCE,BASE(IRAYR3),SIGT,PIJ,IQUA3,ISTAT,
     1   IBASE(INMC3),BASE(IPROCE),BASE(ISURFA),BASE(IPOURC),IMPX,
     2   BASE(IIAP),BASE(IPIB),BASE(IPBI),BASE(IPSS),BASE(IPBB))
         CALL RLSARA(BASE(IPBB))
         CALL RLSARA(BASE(IPSS))
         CALL RLSARA(BASE(IPBI))
         CALL RLSARA(BASE(IPIB))
         CALL RLSARA(BASE(IIAP))
      ELSE IF(ITG.EQ.4) THEN
         CALL LCMSIX(IPTRK,'EURYDICE',1)
         CALL LCMGET(IPTRK,'PARAM',IPAR)
         IHEX=IPAR(1)
         MULTC=IPAR(2)
         IWIGN=IPAR(3)
         NMCEL=IPAR(4)
         NMERGE=IPAR(5)
         NGEN=IPAR(6)
         IJAT=IPAR(7)
         LMAIL=IPAR(15)
         IXX4=LCMIOF(IPTRK,'XX')
         IYY4=LCMIOF(IPTRK,'YY')
         INMC4=LCMIOF(IPTRK,'NMC')
         IRAYR4=LCMIOF(IPTRK,'RAYRE')
         IMAIL=LCMIOF(IPTRK,'MAIL')
         IF(LMAIL.GT.0) THEN
            IIZMAI=LCMIOF(IPTRK,'ZMAILI')
            IRZMAI=LCMIOF(IPTRK,'ZMAILR')
         ELSE
*           THIS INFO IS NOT REQUIRED IN THE CALLED ROUTINE.
            IIZMAI=IMAIL
            IRZMAI=IMAIL
         ENDIF
         IIFR=LCMIOF(IPTRK,'IFR')
         IALB=LCMIOF(IPTRK,'ALB')
         IINUM=LCMIOF(IPTRK,'INUM')
         IMIX=LCMIOF(IPTRK,'MIX')
         IDVX=LCMIOF(IPTRK,'DVX')
         IIGEN=LCMIOF(IPTRK,'IGEN')
         CALL LCMSIX(IPTRK,' ',2)
*
         NCOUR=4
         IF(IHEX.NE.0) NCOUR=6
         CALL SETARA(BASE,2*IJAT*IJAT,IPSSB)
         CALL SETARA(BASE,NREG,ISIGT2)
         IF(MULTC.EQ.1) THEN
            CALL SETARA(BASE,NREG,IPIS)
            CALL SETARA(BASE,NGEN,IPSS)
            CALL SETARA(BASE,NGEN,ISCAL1)
            CALL SETARA(BASE,NGEN,ISCAL2)
            CALL SETARA(BASE,NGEN,IROUT)
            CALL SYBRX2(NREG,SIGT,PIJ,IMPX,NCOUR,IWIGN,NMCEL,NMERGE,
     1      NGEN,IPAR(8),BASE(IXX4),BASE(IYY4),IBASE(INMC4),
     2      BASE(IRAYR4),IBASE(IIFR),BASE(IALB),IBASE(IINUM),
     3      IBASE(IMIX),BASE(IDVX),IBASE(IIGEN),BASE(IPIS),BASE(IPSS),
     4      BASE(IPSSB),BASE(ISIGT2),BASE(ISCAL1),BASE(ISCAL2),
     5      BASE(IROUT))
            CALL RLSARA(BASE(IROUT))
            CALL RLSARA(BASE(ISCAL2))
            CALL RLSARA(BASE(ISCAL1))
            CALL RLSARA(BASE(IPSS))
            CALL RLSARA(BASE(IPIS))
         ELSE IF(MULTC.EQ.2) THEN
            CALL SETARA(BASE,NREG,IPIS)
            CALL SETARA(BASE,NGEN,IPSS)
            CALL SETARA(BASE,NGEN,ISCAL1)
            CALL SETARA(BASE,NGEN,ISCAL2)
            CALL SETARA(BASE,NGEN,IROUT)
            CALL SYBRX3(NREG,SIGT,PIJ,IMPX,NCOUR,IWIGN,NMCEL,NMERGE,
     1      NGEN,IJAT,IPAR(8),BASE(IXX4),BASE(IYY4),IBASE(INMC4),
     2      BASE(IRAYR4),IBASE(IIFR),BASE(IALB),IBASE(IINUM),
     3      IBASE(IMIX),BASE(IDVX),IBASE(IIGEN),BASE(IPIS),BASE(IPSS),
     4      BASE(IPSSB),BASE(ISIGT2),BASE(ISCAL1),BASE(ISCAL2),
     5      BASE(IROUT))
            CALL RLSARA(BASE(IROUT))
            CALL RLSARA(BASE(ISCAL2))
            CALL RLSARA(BASE(ISCAL1))
            CALL RLSARA(BASE(IPSS))
            CALL RLSARA(BASE(IPIS))
         ELSE IF(MULTC.EQ.3) THEN
           CALL SETARA(BASE,NCOUR*NREG,IPIS)
           CALL SETARA(BASE,NCOUR*NCOUR*NGEN,IPSS)
           CALL SYBRX4(NREG,SIGT,PIJ,IMPX,NCOUR,NMCEL,NMERGE,NGEN,IJAT,
     1     IPAR(8),BASE(IXX4),BASE(IYY4),IBASE(INMC4),BASE(IRAYR4),
     2     IBASE(IMAIL),BASE(IIZMAI),BASE(IRZMAI),IBASE(IIFR),
     3     BASE(IALB),IBASE(IINUM),IBASE(IMIX),BASE(IDVX),IBASE(IIGEN),
     4     BASE(IPIS),BASE(IPSS),BASE(IPSSB),BASE(ISIGT2))
           CALL RLSARA(BASE(IPSS))
           CALL RLSARA(BASE(IPIS))
         ELSE IF(MULTC.EQ.4) THEN
           NCOUR=3*NCOUR
           CALL SETARA(BASE,NCOUR*NREG,IPIS)
           CALL SETARA(BASE,NCOUR*NCOUR*NGEN,IPSS)
           CALL SYBRX5(NREG,SIGT,PIJ,IMPX,NCOUR,NMCEL,NMERGE,NGEN,IJAT,
     1     IPAR(8),BASE(IXX4),BASE(IYY4),IBASE(INMC4),BASE(IRAYR4),
     2     IBASE(IMAIL),BASE(IIZMAI),BASE(IRZMAI),IBASE(IIFR),
     3     BASE(IALB),IBASE(IINUM),IBASE(IMIX),BASE(IDVX),IBASE(IIGEN),
     4     BASE(IPIS),BASE(IPSS),BASE(IPSSB),BASE(ISIGT2))
           CALL RLSARA(BASE(IPSS))
           CALL RLSARA(BASE(IPIS))
         ELSE
            CALL XABORT('SYBCP1: UNKNOWN CP MODULE(1).')
         ENDIF
         CALL RLSARA(BASE(ISIGT2))
         CALL RLSARA(BASE(IPSSB))
      ELSE IF(ITG.EQ.10) THEN
         CALL LCMSIX(IPTRK,'BIHET',1)
         CALL LCMGET(IPTRK,'PARAM',IPAR)
         IR1=IPAR(1)
         IR2=IPAR(2)
         NREG2=IPAR(3)
         NG=IPAR(4)
         NSMAX=IPAR(5)
         ITGOLD=IPAR(6)
         MICRO=IPAR(7)
         IQUA10=IPAR(8)
         INS=LCMIOF(IPTRK,'NS')
         IIBI=LCMIOF(IPTRK,'IBI')
         IRS=LCMIOF(IPTRK,'RS')
         IFRACT=LCMIOF(IPTRK,'FRACT')
         IVOLK=LCMIOF(IPTRK,'VOLK')
         CALL LCMSIX(IPTRK,' ',2)
*
         CALL SETARA(BASE,NREG2,IRRR)
         CALL SETARA(BASE,NREG2,ISIGT0)
         CALL SETARA(BASE,NG*NSMAX*NREG2,IQKD)
*
         CALL SETARA(BASE,NSMAX*NSMAX,IQKN)
         CALL SYBHT1(IR1,NREG,SIGT,NREG2,NG,NSMAX,MICRO,IQUA10,
     1   IBASE(INS),IBASE(IIBI),BASE(IRS),BASE(IFRACT),BASE(IVOLK),PIJ,
     2   BASE(IRRR),BASE(ISIGT0),BASE(IQKD),BASE(IQKN))
         CALL RLSARA(BASE(IQKN))
*
         CALL SETARA(BASE,NREG2*NREG2,IPIL)
         CALL SYBCP2 (IPTRK,ITGOLD,IMPX-10,NREG2,BASE(ISIGT0),
     1   BASE(IPIL))
*
         CALL SYBHT2 (IR1,NREG,NREG2,NG,NSMAX,IBASE(INS),IBASE(IIBI),
     1   BASE(IFRACT),BASE(IVOLK),PIJ,BASE(IRRR),BASE(ISIGT0),
     2   BASE(IQKD),BASE(IPIL))
         CALL RLSARA(BASE(IPIL))
         CALL RLSARA(BASE(ISIGT0))
         CALL RLSARA(BASE(IQKD))
         CALL RLSARA(BASE(IRRR))
      ELSE
         CALL XABORT('SYBCP1: UNKNOWN CP MODULE(2).')
      ENDIF
*
      IF(IMPX.GE.7) THEN
         WRITE (6,1130) (J,J=1,NREG)
         DO 90 I=1,NREG
         WRITE (6,1140) I,(PIJ(I,J),J=1,NREG)
   90    CONTINUE
         WRITE (6,'(//)')
      ENDIF
      RETURN
*
 1130 FORMAT (//41H REDUCED COLLISION PROBABILITIES MATRIX ://
     1 (11X,2HJ=,I4,:,5X,2HJ=,I4,:,5X,2HJ=,I4,:,5X,2HJ=,I4,:,5X,2HJ=,
     2 I4,:,5X,2HJ=,I4,:,5X,2HJ=,I4,:,5X,2HJ=,I4,:,5X,2HJ=,I4,:,5X,
     3 2HJ=,I4,:,5X,2HJ=,I4))
 1140 FORMAT (3H I=,I4,2H: ,1P,11E11.3/(9X,11E11.3))
      END
