*DECK XL3
      SUBROUTINE XL3(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
*-----------------------------------------------------------------------
*
* EXCELL TYPE (3-D) TRACKING MODULE.
*
* INPUT/OUTPUT PARAMETERS:
*  NENTRY : NUMBER OF LINKED LISTS OR FILES USED BY THE MODULE.
*  HENTRY : CHARACTER*12 NAME OF EACH LINKED LIST OR FILE.
*  IENTRY : =1 LINKED LIST; =2 XSM FILE; =3 SEQUENTIAL BINARY FILE;
*           =4 SEQUENTIAL ASCII FILE.
*  JENTRY : =0 THE LINKED LIST OR FILE IS CREATED.
*           =1 THE LINKED LIST OR FILE IS OPEN FOR MODIFICATIONS;
*           =2 THE LINKED LIST OR FILE IS OPEN IN READ-ONLY MODE.
*  KENTRY : =FILE UNIT NUMBER; =LINKED LIST ADDRESS OTHERWISE.
*           DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),JENTRY(NENTRY),
*           KENTRY(NENTRY)
*
* LINKED LIST / XSM FILE:
*  HENTRY(1) : CREATE    TYPE(L_PIJ).
*  HENTRY(2) : CREATE    TYPE(L_TRACK).
*  HENTRY(3) : READ-ONLY TYPE(L_GEOM).
*  HENTRY(4) : READ-ONLY TYPE(L_MACROLIB).
*
*----------------------------------------- AUTHOR: R. ROY ; 04/15/96 ---
*----------------------------------------- MODIFY: R. ROY ; 05/03/00 ---
*
      IMPLICIT  NONE
      INTEGER   NENTRY,IOUT,NSTATE
      CHARACTER NAMMOD*12
      PARAMETER( IOUT=6,NSTATE=20,NAMMOD='EXCELL:     ')
      CHARACTER NAMSBR*6
      PARAMETER( NAMSBR='XL3   ')
      CHARACTER HENTRY(*)*12,TEXT4*4,TEXT12*12,TITLE*72,HSIGN*12
      LOGICAL   LASS,LDRASS
      DOUBLE PRECISION DFLOTT
      INTEGER   IENTRY(*),JENTRY(*),KENTRY(*),ITITL(18),
     1          ISTATE(NSTATE),KCHAR(3)
      INTEGER   I,J,ITRANC,NANIS,MAXPTS,MAXMIX,NGRP,IPRT,NORE
      REAL      CUTOFX
      INTEGER   INDIC,NITMA
      REAL      FLOTT
* 
      INTEGER   IKGEOM, IKMACR, IKTRK, IKSYS, IEN
      INTEGER   IPGEOM, IPMACR, IPTRK, IPSYS
      INTEGER   XSSIGT, XSSIGW, XSSIG1, MATCOD, VOLUME, KEYFLX
*
      REAL            RD
      COMMON          RD(1)
      INTEGER         ID(1)
      EQUIVALENCE    (RD(1),ID(1))
C----
C  PRINT CREDITS
C----
      WRITE(IOUT,6900) NAMMOD
      WRITE(IOUT,6910)
*
* PARAMETER VALIDATION.
      IKSYS=1
      IKTRK=2
      IKGEOm=0
      IKMACR=0
      IF(NENTRY .LT. 4) CALL XABORT(NAMSBR//
     >': AT LEAST FOUR DATA STRUCTURES REQUIRED')
      IF(IENTRY(IKSYS) .NE. 1 .AND. IENTRY(IKSYS) .NE. 2) 
     >  CALL XABORT(NAMSBR//
     >': FIRST DATA STRUCTURE NOT A LINKED LIST OR XSM FILE')
      IF(JENTRY(IKSYS) .NE. 0) CALL XABORT(NAMSBR//
     >': FIRST DATA STRUCTURE NOT IN CREATE MODE')
      HSIGN='L_PIJ'
      IPSYS= KENTRY(IKSYS)
      READ(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
      CALL LCMPUT(IPSYS,'SIGNATURE',3,3,KCHAR)
      IF(IENTRY(IKTRK) .NE. 1) CALL XABORT(NAMSBR//
     >': SECOND DATA STRUCTURE NOT A LINKED LIST')
      IF(JENTRY(IKTRK) .NE. 0) CALL XABORT(NAMSBR//
     >': SECOND DATA STRUCTURE NOT IN CREATE MODE')
      HSIGN='L_TRACK'
      IPTRK= KENTRY(IKTRK)
      READ(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
      CALL LCMPUT(IPTRK,'SIGNATURE',3,3,KCHAR)
      HSIGN='EXCELL'
      READ(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
      CALL LCMPUT(IPTRK,'TRACK-TYPE',3,3,KCHAR)
*----
* Find geometry and macrolib structure
*----
      DO 100 IEN=3,4
        IF(IENTRY(IEN) .NE. 1 .AND. IENTRY(IEN) .NE. 2) THEN 
          IF(IEN .EQ. 3) THEN 
            CALL XABORT(NAMSBR//
     >      ': THIRD DATA STRUCTURE NOT A LINKED LIST OR XSM FILE') 
          ELSE  
            CALL XABORT(NAMSBR//
     >      ': FOURTH DATA STRUCTURE NOT A LINKED LIST OR XSM FILE') 
          ENDIF
        ENDIF
        IF(JENTRY(IEN) .NE. 2) THEN
          IF(IEN .EQ. 3) THEN 
            CALL XABORT(NAMSBR//
     >      ': THIRD DATA STRUCTURE NOT IN READ-ONLY MODE') 
          ELSE  
            CALL XABORT(NAMSBR//
     >      ': FOURTH DATA STRUCTURE NOT IN READ-ONLY MODE') 
          ENDIF
        ENDIF
        CALL LCMGET(KENTRY(IEN),'SIGNATURE',KCHAR)
        WRITE(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
        TEXT12=HENTRY(IEN)
        IF(HSIGN .EQ. 'L_GEOM      ') THEN
          IKGEOM=IEN
        ELSE IF(HSIGN .EQ. 'L_LIBRARY') THEN
          IKMACR=-IEN
        ELSE IF(HSIGN .EQ. 'L_MACROLIB') THEN
          IKMACR=IEN
        ELSE
          CALL XABORT(NAMSBR//': SIGNATURE OF '//TEXT12//' IS '
     >    //HSIGN//'. L_GEOM, L_LIBRARY OR L_MACROLIB EXPECTED.')
        ENDIF 
 100  CONTINUE
      IF(IKGEOM .EQ. 0) CALL XABORT(NAMSBR//
     >': NO L_GEOM DATA STRUCTURE AVAILABLE.')
      IF(IKMACR .EQ. 0) CALL XABORT(NAMSBR//
     >': NO L_LIBRARY OR L_MACROLIB DATA STRUCTURE AVAILABLE.') 
*----
* Recover geometry parameters
*----
      IPGEOM= KENTRY(IKGEOM)
      CALL LCMGET(IPGEOM,'STATE-VECTOR',ISTATE)
      MAXPTS=ISTATE(6)
*----
* Recover macrolib parameters
*----
      IPMACR= KENTRY(ABS(IKMACR))
      IF(IKMACR .LT. 0) CALL LCMSIX(IPMACR,'MACROLIB',1)
      CALL XDRSET(ISTATE,NSTATE,0)
      CALL LCMGET(IPMACR,'STATE-VECTOR',ISTATE)
      NGRP=   ISTATE(1)
      MAXMIX= ISTATE(2)
      ITRANC= ISTATE(6)
*
      IPRT=1
      TITLE=' '
      NANIS=1
      NORE=0
      CUTOFX=0.0
   40 CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
      IF(INDIC.EQ.10) GO TO 50
      IF(INDIC.NE.3) CALL XABORT(NAMSBR//
     >': CHARACTER DATA EXPECTED.')
      IF(TEXT4.EQ.'EDIT') THEN
         CALL REDGET(INDIC,IPRT,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT(NAMSBR//
     >   ': INTEGER DATA EXPECTED(1).')
      ELSE IF(TEXT4.EQ.'MAXR') THEN
         CALL REDGET(INDIC,MAXPTS,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT(NAMSBR//
     >   ': INTEGER DATA EXPECTED(2).')
      ELSE IF(TEXT4.EQ.'TITL') THEN
         CALL REDGET(INDIC,NITMA,FLOTT,TITLE,DFLOTT)
         IF(INDIC.NE.3) CALL XABORT(NAMSBR//
     >   ': TITLE EXPECTED.')
      ELSE IF(TEXT4.EQ.'RENO') THEN
         NORE=0
      ELSE IF(TEXT4.EQ.'RENM') THEN
C----
C  RENM NOT AVAILABLE HERE REVERT TO RENO
C----
         NORE=0
      ELSE IF(TEXT4.EQ.'NORE') THEN
         NORE=1
      ELSE IF(TEXT4.EQ.'CUT') THEN
         CALL REDGET(INDIC,NITMA, FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.2.OR.FLOTT.LT.0.0) THEN
            CALL XABORT(NAMSBR//': CUTOFF MUST BE A POSITIVE REAL')
         ENDIF
         CUTOFX=FLOTT
      ELSE IF(TEXT4.EQ.'TRAK') THEN
         GO TO 50
      ELSE
         CALL XABORT(NAMSBR//': '//TEXT4//' IS AN INVALID KEY WORD.')
      ENDIF
      GO TO 40
*
* CHECK GEOMETRY CONSISTENCY.
   50 LASS=LDRASS(IPGEOM,1,IPRT)
*
* BUILD MULTI-GROUP CROSS-SECTIONS.
      CALL SETARA(RD,NGRP*(MAXMIX+1),XSSIGT)
      CALL SETARA(RD,NGRP*(MAXMIX+1),XSSIGW)
      CALL SETARA(RD,     (MAXMIX+1),XSSIG1)
      CALL XL3MAC(IPMACR,IPSYS,NGRP,MAXMIX,ITRANC,
     1            RD(XSSIGT),RD(XSSIGW),RD(XSSIG1),IPRT)
*
      IF(TITLE.NE.' ') THEN
         READ(TITLE,'(18A4)') (ITITL(I),I=1,18)
         CALL LCMPUT(IPTRK,'TITLE',18,3,ITITL)
      ENDIF
      IF(IPRT.GT.1) WRITE(IOUT,'(1X,A72//)') TITLE
*
      IF(MAXPTS.EQ.0) CALL XABORT(NAMSBR//': MAXPTS NOT DEFINED.')
      CALL SETARA(ID,MAXPTS,MATCOD)
      CALL SETARA(RD,MAXPTS,VOLUME)
      CALL SETARA(ID,MAXPTS,KEYFLX)
      CALL XL3DRV (IPSYS,IPTRK,IPGEOM,IPRT,MAXPTS,NORE,
     1             TITLE,CUTOFX,
     2             NGRP,MAXMIX,RD(XSSIGT),RD(XSSIGW),
     3             ID(MATCOD),RD(VOLUME),ID(KEYFLX))
      CALL RLSARA(ID(KEYFLX))
      CALL RLSARA(RD(VOLUME))
      CALL RLSARA(ID(MATCOD))
      CALL RLSARA(RD(XSSIG1))
      CALL RLSARA(RD(XSSIGW))
      CALL RLSARA(RD(XSSIGT))
      IF(IKMACR .LT. 0) CALL LCMSIX(IPMACR,'MACROLIB',2)
*
      WRITE(IOUT,6901) NAMMOD
      RETURN
 6900 FORMAT('->@BEGIN MODULE : ',A12)
 6901 FORMAT('->@END MODULE   : ',A12)
 6910 FORMAT('->@DESCRIPTION  : 3-D EXCELT MODULE COMBINED WITH ASM'/
     >       '->@CREDITS      : R. ROY'/
     >       '->@COPYRIGHTS   : ECOLE POLYTECHNIQUE DE MONTREAL ')
      END
